//for delete request
var gDelAPIRequest;

function doGoToUser(URL)
{
	if( gLatestItems == null )
	{
		alert( "User not found" );
	}
	for( i = 0; i < gLatestItems.length; i++ )
	{
		var link = gLatestItems[i].getElementsByTagName( "link" );
		if( URL == link[0].firstChild.nodeValue )
		{
			var creator = gLatestItems[i].getElementsByTagNameNS(  "http://purl.org/dc/elements/1.1/", "creator" );
			var userURL = "http://del.icio.us/" + creator[0].firstChild.nodeValue;
			var wnd = window.parent.document.getElementById( "content" );
			if( wnd != null ) wnd.contentWindow.location.href= userURL;
			return;
		}
	}
	
	alert( "User not found" );

}

function doGoToUserTags(URL)
{
	if( gLatestItems == null )
	{
		alert( "User not found" );
	}
	for( i = 0; i < gLatestItems.length; i++ )
	{
		var link = gLatestItems[i].getElementsByTagName( "link" );
		if( URL == link[0].firstChild.nodeValue )
		{
			var creator = gLatestItems[i].getElementsByTagNameNS(  "http://purl.org/dc/elements/1.1/", "creator" );
			var tag = document.getElementById( "category" ).value;
			var userURL = "http://del.icio.us/" + creator[0].firstChild.nodeValue + "/";
			userURL += tag.replace(/\s/g, "+");
			var wnd = window.parent.document.getElementById( "content" );
			if( wnd != null ) wnd.contentWindow.location.href= userURL;
			return;
		}
	}
	
	alert( "User not found" );
}

function doDelete(URL)
{
	gDelAPIRequest = new XMLHttpRequest();
	gDelAPIRequest.onreadystatechange = getDeleteResponse;
	var linkDel = "http://del.icio.us/api/posts/delete?url=";
	linkDel += encodeURIComponent( URL );
	var username = getDelCharPref("username");
	var password = getDelCharPref("password");
	if( (password == null) || (username == null) )
	{
		alert("Please set username and/or password");
		return;
	}
	gDelAPIRequest.open( "GET", linkDel, true, username, password );
	gDelAPIRequest.send(null);	
}

function getDeleteResponse()
{
	if( gDelAPIRequest.readyState == 4 )
	{
		var response = gDelAPIRequest.responseText;
		var searchDone = /code=\"done\"/;
		if( response.match( searchDone ) )
		{
			alert( "Post deleted" );
		}
		else
		{
			alert( "Delete failed" );
		}
	}
}

function doMarkRead( Url )
{
	var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("UChrm",Components.interfaces.nsIFile);
	file.append("readposts.xml");
	if( file.exists() == false ) 
	{ 
		createReadPostsFile(file);
	}

	try {
	if( gAllReadPostsDOM == null )
	{
		var gAllReadPostsDOM = document.implementation.createDocument("","",null);
		gAllReadPostsDOM.async=false;
		var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri = ioService.newFileURI(file);
		gAllReadPostsDOM.load(uri.spec);
	}
	var postElem = gAllReadPostsDOM.createElement("post");
	postElem.setAttribute("href", Url );
	gAllReadPostsDOM.documentElement.appendChild( postElem );
	var serializer = new XMLSerializer();
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	foStream.init(file, 0x02 | 0x08, 0664, 0); // write, create, truncate
	//write the updated DOM to the file
	serializer.serializeToStream( gAllReadPostsDOM, foStream, "UTF-8" );
	foStream.close();
	}
	catch( e )
	{
		alert( e );
	}
}

function createReadPostsFile( file )
{
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	// use 0x02 | 0x10 to open file for appending.
	foStream.init(file, 0x02 | 0x08, 0664, 0); // write, create, truncate
	var data = "<?xml version='1.0' ?>\n";
	foStream.write(data, data.length);
	data = "<readPosts>\n";
	foStream.write(data, data.length);
	data = "</readPosts>";
	foStream.write(data, data.length);
	foStream.close();	
}
